<template>
  <v-sheet class="d-flex flex-wrap pa-5">
    <v-sheet v-for="(weekDay , index) in weekDays" :key="`week_day_date_${index}`" class="day-col mx-1 font-weight-bold text-center">
      {{ weekDay }}
    </v-sheet>
    <v-sheet
      v-for="(n,index) in monthDays" :key="`date_col_${index}`"
      class="date-col mx-2 text-center rounded-circle text-caption font-weight-bold py-1 my-1"
      :color="n === day ? `primary` : `transparent`" @click="changeDay(n)">
      <span :class="n === day ? `white--text` : `black--text`">{{ n }}</span>
    </v-sheet>
  </v-sheet>
</template>

<script>
import {mapState} from "vuex";
import dateMixin from "~/mixins/dateMixin";

export default {
  name: "TaDatePicker",
  mixins: [dateMixin],
  data() {
    return {
      weekDaysTitle: {
        georgian: ['Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat', 'Sun'],
        jalali: ['شنبه', 'یک', 'دو', 'سه', 'چهار', 'پنج', 'جمعه']
      }
    }
  },
  computed: {
    ...mapState({
      mFirstDayWeek: (state) => state.date.mFirstDayWeek,
      days: (state) => state.date.days,
    }),
    weekDays() {
      return this.calendarLocale === 'fa' ? this.weekDaysTitle.jalali : this.weekDaysTitle.georgian
    },
    monthDays() {
      const dates = [];
      let dayCounter = 1
      for (let i = 1; i <= 35; i++) {
        // if day bigger than start day week
        // if day lower than month days number
        const firstDay = this.mFirstDayWeek.firstDay
        if (i < firstDay || dayCounter > this.days) {
          dates.push(null)
        } else {
          dates.push(dayCounter)
          dayCounter++
        }
      }
      return dates
    }
  },
  methods: {
    changeDay(day) {
      this.$store.dispatch('date/setDay', day)
    }
  }
}
</script>

<style scoped>
.date-col {
  flex: 1 0 calc(14.285% - 16px);
}

.day-col {
  flex: 1 0 calc(14.285% - 8px);
}
</style>
